using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace Simplabs.NetDocumentor {

	/// <summary>
	/// Exception that is thrown on errors during connection of the plugin to the IDE
	/// </summary>
	[Serializable]
	public class ConnectionException : NetDocumentorException {

		/// <summary>
		/// Initializes a new ConnectionException
		/// </summary>
		public ConnectionException() : this(string.Empty, null) {
		}

		/// <summary>
		/// Initializes a new ConnectionException
		/// </summary>
		/// <param name="message">The exception message</param>
		public ConnectionException(string message) : this(message, null) {
		}

		/// <summary>
		/// Initializes a new ConnectionException
		/// </summary>
		/// <param name="message">The exception message</param>
		/// <param name="innerExeption">The inner exception</param>
		public ConnectionException(string message, Exception innerException) : base(message, innerException) {
		}

		/// <summary>
		/// Initializes a new ConnectionException
		/// </summary>
		/// <param name="info">The object that holds the serialized object data.</param>
		/// <param name="context">The contextual information about the source or destination.</param>
		protected ConnectionException(SerializationInfo info, StreamingContext context) : base(info, context) {
		}

	}

}