using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace Simplabs.NetDocumentor.Documentation {

	/// <summary>
	/// Exception that is thrown on errors during documentation
	/// </summary>
	[Serializable]
	public class DocumentationException : NetDocumentorException {

		/// <summary>
		/// Initializes a new DocumentationException
		/// </summary>
		public DocumentationException() : this(string.Empty, null) {
		}

		/// <summary>
		/// Initializes a new DocumentationException
		/// </summary>
		/// <param name="message">The exception message</param>
		public DocumentationException(string message) : this(message, null) {
		}

		/// <summary>
		/// Initializes a new DocumentationException
		/// </summary>
		/// <param name="message">The exception message</param>
		/// <param name="innerExeption">The inner exception</param>
		public DocumentationException(string message, Exception innerException) : base(message, innerException) {
		}

		/// <summary>
		/// Initializes a new DocumentationException
		/// </summary>
		/// <param name="info">The object that holds the serialized object data.</param>
		/// <param name="context">The contextual information about the source or destination.</param>
		protected DocumentationException(SerializationInfo info, StreamingContext context) : base(info, context) {
		}

	}

}