using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace Simplabs.NetDocumentor.IdeIntegration {

	/// <summary>
	/// Exception that is thrown on errors concerning the integration with the IDE
	/// </summary>
	[Serializable]
	public class IntegrationException : NetDocumentorException {

		/// <summary>
		/// Initializes a new IntegrationException
		/// </summary>
		public IntegrationException() : this(string.Empty, null) {
		}

		/// <summary>
		/// Initializes a new IntegrationException
		/// </summary>
		/// <param name="message">The exception message</param>
		public IntegrationException(string message) : this(message, null) {
		}

		/// <summary>
		/// Initializes a new IntegrationException
		/// </summary>
		/// <param name="message">The exception message</param>
		/// <param name="innerExeption">The inner exception</param>
		public IntegrationException(string message, Exception innerException) : base(message, innerException) {
		}

		/// <summary>
		/// Initializes a new IntegrationException
		/// </summary>
		/// <param name="info">The object that holds the serialized object data.</param>
		/// <param name="context">The contextual information about the source or destination.</param>
		protected IntegrationException(SerializationInfo info, StreamingContext context) : base(info, context) {
		}

	}

}