using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace Simplabs.NetDocumentor {

	/// <summary>
	/// The main Exception class for the Addin
	/// </summary>
	[Serializable]
	public class NetDocumentorException : Exception {

		/// <summary>
		/// Initializes a new AddinException
		/// </summary>
		public NetDocumentorException() : this(string.Empty, null) {
		}

		/// <summary>
		/// Initializes a new AddinException
		/// </summary>
		/// <param name="message">The exception message</param>
		public NetDocumentorException(string message) : this(message, null) {
		}

		/// <summary>
		/// Initializes a new AddinException
		/// </summary>
		/// <param name="message">The exception message</param>
		/// <param name="innerExeption">The inner exception</param>
		public NetDocumentorException(string message, Exception innerException) : base(message, innerException) {
		}

		/// <summary>
		/// Initializes a new AddinException
		/// </summary>
		/// <param name="info">The object that holds the serialized object data.</param>
		/// <param name="context">The contextual information about the source or destination.</param>
		protected NetDocumentorException(SerializationInfo info, StreamingContext context) : base(info, context) {
		}

	}

}