using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace Simplabs.NetDocumentor.Documentation {

	/// <summary>
	/// Exception that is thrown on errors during processing of settings
	/// </summary>
	[Serializable]
	public class SettingsException : NetDocumentorException {

		/// <summary>
		/// Initializes a new SettingsException
		/// </summary>
		public SettingsException()
			: this(string.Empty, null) {
		}

		/// <summary>
		/// Initializes a new SettingsException
		/// </summary>
		/// <param name="message">The exception message</param>
		public SettingsException(string message)
			: this(message, null) {
		}

		/// <summary>
		/// Initializes a new SettingsException
		/// </summary>
		/// <param name="message">The exception message</param>
		/// <param name="innerExeption">The inner exception</param>
		public SettingsException(string message, Exception innerException)
			: base(message, innerException) {
		}

		/// <summary>
		/// Initializes a new SettingsException
		/// </summary>
		/// <param name="info">The object that holds the serialized object data.</param>
		/// <param name="context">The contextual information about the source or destination.</param>
		protected SettingsException(SerializationInfo info, StreamingContext context)
			: base(info, context) {
		}

	}

}