using System;
using System.Collections.Generic;
using System.Text;
using Simplabs.NetDocumentor.Settings;
using System.Globalization;
using System.Windows.Forms;
using Simplabs.NetDocumentor.Documentation;

namespace Simplabs.NetDocumentor.UI {

	/// <summary>
	/// The options page for Basic settings
	/// </summary>
	public sealed class BasicOptionsPage : OptionsPage {

		/// <summary>
		/// Initializes a new CppOptionsPage
		/// </summary>
		public BasicOptionsPage() : base() {
			InitializeComponent();
		}

		/// <summary>
		/// Performs manual initialization of the form
		/// </summary>
		protected override void ManualInitialize() {
			Features = FeaturesStore.GetFeatures(BasicDocumentor.LanguagePrefix);
			labelCaption.Text = string.Format(
				global::Simplabs.NetDocumentor.Properties.Resources.Culture,
				labelCaption.Text,
				global::Simplabs.NetDocumentor.Properties.Resources.BasicDocumentationName
			);
		}

		#region Component Designer generated code

		private void InitializeComponent() {
			this.SuspendLayout();
			this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
			this.Name = "BasicOptionsPage";
			this.ResumeLayout(false);
			this.PerformLayout();
		}

		#endregion

	}

}