using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace Simplabs.NetDocumentor.UI {

	/// <summary>
	/// Exception that is thrown on errors in the UI
	/// </summary>
	[Serializable]
	public class UIException : NetDocumentorException {

		/// <summary>
		/// Initializes a new UIException
		/// </summary>
		public UIException() : this(string.Empty, null) {
		}

		/// <summary>
		/// Initializes a new UIException
		/// </summary>
		/// <param name="message">The exception message</param>
		public UIException(string message) : this(message, null) {
		}

		/// <summary>
		/// Initializes a new UIException
		/// </summary>
		/// <param name="message">The exception message</param>
		/// <param name="innerExeption">The inner exception</param>
		public UIException(string message, Exception innerExeption) : base(message, innerExeption) {
		}

		/// <summary>
		/// Initializes a new UIException
		/// </summary>
		/// <param name="info">The object that holds the serialized object data.</param>
		/// <param name="context">The contextual information about the source or destination.</param>
		protected UIException(SerializationInfo info, StreamingContext context) : base(info, context) {
		}

	}

}