'-----------------------------------------------------------------------
'  This file is part of the Microsoft .NET SDK Code Samples.
' 
'  Copyright (C) Microsoft Corporation.  All rights reserved.
' 
'This source code is intended only as a supplement to Microsoft
'Development Tools and/or on-line documentation.  See these other
'materials for detailed information regarding Microsoft code samples.
' 
'THIS CODE AND INFORMATION ARE PROVIDED AS IS WITHOUT WARRANTY OF ANY
'KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
'IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
'PARTICULAR PURPOSE.
'-----------------------------------------------------------------------

Imports System.IO
Imports System.Globalization
Imports System.Security.AccessControl

Namespace Microsoft.Samples.FileDemo

	''' <summary>
	''' 
	''' </summary>
	Friend Enum FileItemType
		''' <summary>
		''' 
		''' </summary>
		File
		''' <summary>
		''' 
		''' </summary>
		Directory
		''' <summary>
		''' 
		''' </summary>
		Other
	End Enum

	''' <summary>
	''' 
	''' </summary>
	Friend Enum DefaultPropertiesView
		''' <summary>
		''' 
		''' </summary>
		General
		''' <summary>
		''' 
		''' </summary>
		Security
		''' <summary>
		''' 
		''' </summary>
		Other
	End Enum

	''' <summary>
	''' 
	''' </summary>
	Friend Enum FileRightShortCuts
		''' <summary>
		''' 
		''' </summary>
		Read = FileSystemRights.ListDirectory Or FileSystemRights.ReadAttributes Or _
				FileSystemRights.ReadExtendedAttributes Or FileSystemRights.ReadPermissions
		''' <summary>
		''' 
		''' </summary>
		ReadAndExecute = FileRightShortCuts.Read Or FileSystemRights.Traverse
		''' <summary>
		''' 
		''' </summary>
		Write = FileSystemRights.WriteData Or FileSystemRights.AppendData Or _
					FileSystemRights.WriteExtendedAttributes Or _
					FileSystemRights.WriteAttributes
		''' <summary>
		''' 
		''' </summary>
		Modify = FileRightShortCuts.ReadAndExecute Or FileRightShortCuts.Write Or _
				FileSystemRights.Delete
		''' <summary>
		''' 
		''' </summary>
		FullControl = FileSystemRights.FullControl
	End Enum
	''' <summary>
	''' 
	''' </summary>

    Module General

		''' <summary>
		''' 
		''' </summary>
		Public Enum DemoCategories
			''' <summary>
			''' 
			''' </summary>
			Created = 1
			''' <summary>
			''' 
			''' </summary>
			Moved = 2
			''' <summary>
			''' 
			''' </summary>
			Deleted = 3
		End Enum

		''' <summary>
		''' 
		''' </summary>
		Public EnvironmentChanged As Boolean
		''' <summary>
		''' 
		''' </summary>
		Public curDir As String
		''' <summary>
		''' 
		''' </summary>
		Public NewName As String
		''' <summary>
		''' 
		''' </summary>
		Public NewValue As String

		''' <summary>
		''' 
		''' </summary>
		''' <param name="d"></param>
		''' <param name="network"></param>
		''' <returns></returns>
		Public Function GetDriveType(ByVal d As DriveInfo, ByVal network As Boolean) As String

			Dim typeName As String

			Select Case d.DriveType
				Case DriveType.Removable
					typeName = "Floppy"
				Case DriveType.CDRom
					typeName = "CD Drive"
				Case DriveType.Fixed
					typeName = "Local Disk"
				Case DriveType.Network
					If Not network Then
						typeName = "Network Drive"
					Else
						typeName = "Unknown"
					End If
				Case Else
					typeName = "Unknown"
			End Select

			Return typeName

		End Function

		''' <summary>
		''' 
		''' </summary>
		''' <param name="d"></param>
		''' <returns></returns>
		Public Function GetDriveIndex(ByVal d As DriveInfo) As Integer

			Select Case d.DriveType
				Case DriveType.Removable
					Return 2
				Case DriveType.CDRom
					Return 0
				Case DriveType.Fixed
					Return 5
				Case DriveType.Network
					Return 7
			End Select

			Return 5

		End Function

		''' <summary>
		''' 
		''' </summary>
		''' <param name="d"></param>
		''' <returns></returns>
		Public Function GetNameAndType(ByVal d As DriveInfo) As String
			Return String.Format(CultureInfo.CurrentCulture, "{0} ({1})", GetDriveType(d, False), d.Name.Substring(0, 2))
		End Function
    End Module
End Namespace