﻿#pragma once 

using namespace System;
using namespace System::Windows::Forms;
using namespace System::Collections;
using namespace System::IO;
using namespace System::Drawing;
using namespace System::Drawing::Printing;

ref class ScribbleDoc;

ref class MainWindow: public Form
{
public:
	static MainWindow^ parentWindow;
	MainWindow();
	virtual ~MainWindow();
	static int documentCount; // static var which keeps track of the document count

	void DisableItems();
	void EnableItems();

private:
	void InitializeComponent();
	void MenuItemHandler( Object^ sender, EventArgs^ e );

	void ToolbarHandler( Object^ sender, ToolBarButtonClickEventArgs^ e );
	void AboutHelp();

	void HelpTopics();

	void Print();

	void ScribblePrintPage( Object^ sender, PrintPageEventArgs^ ev );

	void PrintPreview();

	void Exit();

	void CloseView();

	void Tile();

	void Cascade();

	void ClearAll();

	void Open();

	void Save();

	void New();

	void NewWindow();

	void ThickLine();

	void PenWidthsDlg();

	ScribbleDoc^ CreateDocument();
	System::ComponentModel::Container^ components;
	PrintDocument^ printDoc;
	HelpProvider^ helpProvider1;
	Windows::Forms::MenuItem^ fileMenuItem;
	Windows::Forms::MenuItem^ editMenuItem;
	Windows::Forms::MenuItem^ viewMenuItem;
	Windows::Forms::MenuItem^ penMenuItem;
	Windows::Forms::MenuItem^ helpMenuItem;
	Windows::Forms::MenuItem^ windowMenuItem;
	Windows::Forms::MenuItem^ newMenuItem;
	Windows::Forms::MenuItem^ openMenuItem;
	Windows::Forms::MenuItem^ closeMenuItem;
	Windows::Forms::MenuItem^ saveMenuItem;
	Windows::Forms::MenuItem^ saveAsMenuItem;
	Windows::Forms::MenuItem^ printMenuItem;
	Windows::Forms::MenuItem^ printPreviewMenuItem;
	Windows::Forms::MenuItem^ exitMenuItem;
	Windows::Forms::MenuItem^ thickLineMenuItem;
	Windows::Forms::MenuItem^ newWindowMenuItem;
	Windows::Forms::MenuItem^ cascadeMenuItem;
	Windows::Forms::MenuItem^ tileMenuItem;
	Windows::Forms::MenuItem^ clearAllMenuItem;
	Windows::Forms::MenuItem^ toolbarMenuItem;
	Windows::Forms::MenuItem^ statusbarMenuItem;
	Windows::Forms::MenuItem^ helpAboutMenuItem;
	Windows::Forms::MenuItem^ helpTopicsMenuItem;
	Windows::Forms::MenuItem^ helpUnmanagedStringMenuItem;
	Windows::Forms::MenuItem^ penWidthMenuItem;
	Windows::Forms::MenuItem^ line1MenuItem;
	Windows::Forms::MenuItem^ line2MenuItem;
	Windows::Forms::MenuItem^ line3MenuItem;

	Windows::Forms::ToolBar^ toolBar1;
	Windows::Forms::StatusBar^ statusBar1;
	Windows::Forms::ImageList^ imageList1;
	Windows::Forms::ToolBarButton^ helpButton;
	Windows::Forms::ToolBarButton^ printButton;
	Windows::Forms::ToolBarButton^ previewButton;
	Windows::Forms::ToolBarButton^ saveButton;
	Windows::Forms::ToolBarButton^ openButton;
	Windows::Forms::ToolBarButton^ newButton;
	Windows::Forms::MainMenu^ mainMenu;
};

