'
' File: BaseObj.vb
'
'---------------------------------------------------------------------
' This file is part of the Microsoft .NET Framework SDK Code Samples.
'
'  Copyright (C) Microsoft Corporation.  All rights reserved.
' 
' This source code is intended only as a supplement to Microsoft
' Development Tools and/or on-line documentation.  See these other
' materials for detailed information regarding Microsoft code samples.
' 
' THIS CODE AND INFORMATION ARE PROVIDED AS IS WITHOUT WARRANTY OF ANY
' KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND/OR FITNESS FOR A
' PARTICULAR PURPOSE.
'---------------------------------------------------------------------

Namespace Microsoft.Samples.RomanLegion

    ''' <summary>
    ''' 
    ''' </summary>
    Public Class BaseObj

        ''' <summary>
        ''' 
        ''' </summary>
        Private myActiveImage As Integer = 0

        ''' <summary>
        ''' 
        ''' </summary>
        Private myLeft As Integer
        ''' <summary>
        ''' 
        ''' </summary>
        Private myTop As Integer

        ''' <summary>
        ''' 
        ''' </summary>
        Private myLeftOld As Integer
        ''' <summary>
        ''' 
        ''' </summary>
        Private myTopOld As Integer

        ''' <summary>
        ''' 
        ''' </summary>
        Private myHorizontalVelocity As Integer
        ''' <summary>
        ''' 
        ''' </summary>
        Private myVerticalVelocity As Integer

        ''' <summary>
        ''' 
        ''' </summary>
        Private myWidth As Integer
        ''' <summary>
        ''' 
        ''' </summary>
        Private myHeight As Integer

        ''' <summary>
        ''' 
        ''' </summary>
        Private myMaximumX As Integer
        ''' <summary>
        ''' 
        ''' </summary>
        Private myMaximumY As Integer

        ''' <summary>
        ''' 
        ''' </summary>
        Private myCurrentGame As Game

        ''' <summary>
        ''' 
        ''' </summary>
        Private fActive As Boolean

        ''' <summary>
        ''' 
        ''' </summary>
        Private myCells() As Bitmap

        ''' <summary>
        ''' 
        ''' </summary>
        Private myCellAttributes() As Imaging.ImageAttributes

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Protected Property LeftOld() As Integer
            Get
                Return myLeftOld
            End Get
            Set(ByVal value As Integer)
                myLeftOld = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Protected Property TopOld() As Integer
            Get
                Return myTopOld
            End Get
            Set(ByVal value As Integer)
                myTopOld = value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Protected Property HorizontalVelocity() As Integer
            Get
                Return myHorizontalVelocity
            End Get
            Set(ByVal value As Integer)
                myHorizontalVelocity = value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Protected Property VerticalVelocity() As Integer
            Get
                Return myVerticalVelocity
            End Get
            Set(ByVal value As Integer)
                myVerticalVelocity = value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Protected Property MaximumX() As Integer
            Get
                Return myMaximumX
            End Get
            Set(ByVal value As Integer)
                myMaximumX = value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Protected Property MaximumY() As Integer
            Get
                Return myMaximumY
            End Get
            Set(ByVal value As Integer)
                myMaximumY = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Protected Property CurrentGame() As Game
            Get
                Return myCurrentGame
            End Get
            Set(ByVal value As Game)
                myCurrentGame = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Protected Property AnimationCells() As Bitmap()
            Get
                Return myCells
            End Get
            Set(ByVal value As Bitmap())
                myCells = value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Protected Property CellAttributes() As System.Drawing.Imaging.ImageAttributes()
            Get
                Return myCellAttributes
            End Get
            Set(ByVal value As System.Drawing.Imaging.ImageAttributes())
                myCellAttributes = value
            End Set
        End Property

        ''' <summary>
        ''' Initializes a new RomanLegion.Microsoft.Samples.RomanLegion.BaseObj.
        ''' </summary>
        ''' <param name="game"></param>
        Public Sub New(ByVal game As Game)

            myCurrentGame = game

            myMaximumX = myCurrentGame.WorldBounds.Width
            myMaximumY = myCurrentGame.WorldBounds.Height

            myLeftOld = 0
            myTopOld = 0
        End Sub

        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="gx"></param>
        Public Sub Draw(ByVal gx As Graphics)

            ' if is to draw
            If (fActive) Then

                gx.DrawImage( _
                    myCells(myActiveImage), _
                    New Rectangle(myLeft, myTop, myWidth, myHeight), _
                    0, _
                    0, _
                    myWidth, _
                    myHeight, _
                    GraphicsUnit.Pixel, _
                    myCellAttributes(myActiveImage))
            End If
        End Sub

        ''' <summary>
        ''' 
        ''' </summary>
        ''' <param name="bmpName"></param>
        ''' <param name="bitmapIndex"></param>
        Public Sub Load(ByVal bmpName As String, ByVal bitmapIndex As Integer)

            Try

                ' Load BMP from file
                myCells(bitmapIndex) = New Bitmap(myCurrentGame.ExecutablePath + "Content\" + bmpName)
                myWidth = myCells(bitmapIndex).Width
                myHeight = myCells(bitmapIndex).Height

            Catch

                ' Any error reading the BMP, create a dummy one
                myCells(bitmapIndex) = New Bitmap(myWidth, myHeight)
                Graphics.FromImage(myCells(bitmapIndex)).FillEllipse(New SolidBrush(Color.White), New Rectangle(0, 0, myWidth - 1, myHeight - 1))
            End Try

            ' Get the color of a background pixel as the Pixel 0,0 
            Dim TranspColor As Color = myCells(bitmapIndex).GetPixel(0, 0)

            ' Set the Attributes for the Transparent color
            myCellAttributes(bitmapIndex) = New Imaging.ImageAttributes()
            myCellAttributes(bitmapIndex).SetColorKey(TranspColor, TranspColor)
        End Sub

        ''' <summary>
        ''' 
        ''' </summary>
        Public Sub Restore()

            ' Restore the Game Background
            myCurrentGame.BufferGraphics.DrawImage( _
                myCurrentGame.BackBmp, _
                myLeft, _
                myTop, _
                New Rectangle(myLeft, myTop, myWidth, myHeight), _
                GraphicsUnit.Pixel)
        End Sub

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Public Property Bounds() As Rectangle
            Get
                Return (New Rectangle(myLeft, myTop, myWidth, myHeight))
            End Get
            Set(ByVal Value As Rectangle)
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Public Property DirtyArea() As Rectangle
            Get
                Return (Rectangle.Union(New Rectangle(myLeft, myTop, myWidth, myHeight), New Rectangle(myLeftOld, myTopOld, myWidth, myHeight)))
            End Get
            Set(ByVal Value As Rectangle)
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Public Property IsAlive() As Boolean
            Get
                Return (fActive)
            End Get
            Set(ByVal Value As Boolean)
                fActive = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Public Property CurrentImage() As Integer
            Get
                Return (myActiveImage)
            End Get
            Set(ByVal value As Integer)
                myActiveImage = value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Public Property CellLeft() As Integer
            Get
                Return (myLeft)
            End Get
            Set(ByVal value As Integer)
                myLeft = Value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Public Property CellTop() As Integer
            Get
                Return (myTop)
            End Get
            Set(ByVal value As Integer)
                myTop = value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Public Property CellWidth() As Integer
            Get
                Return (myWidth)
            End Get
            Set(ByVal value As Integer)
                myWidth = value
            End Set
        End Property

        ''' <summary>
        ''' Gets or sets the
        ''' </summary>
        Public Property CellHeight() As Integer
            Get
                Return (myHeight)
            End Get
            Set(ByVal value As Integer)
                myHeight = value
            End Set
        End Property

    End Class

End Namespace
   
